/* ////////////////////////////////////////////////////////////

File Name: ysshellextedit_splitop.h
Copyright (c) 2015 Soji Yamakawa.  All rights reserved.
http://www.ysflight.com

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//////////////////////////////////////////////////////////// */

#ifndef YSSHELLEXTEDIT_SPLITOP_IS_INCLUDED
#define YSSHELLEXTEDIT_SPLITOP_IS_INCLUDED
/* { */

#include <ysshellextedit.h>
#include "ysshellext_splitop.h"

class YsShellExtEdit_CutByPlane : private YsShell_CutByPlane
{
public:
	YSRESULT CutByPolygon(YsShellExtEdit &shl,YSSIZE_T np,const YsVec3 p[]);
	YSRESULT CutByPolygon(YsShellExtEdit &shl,YSSIZE_T np,const YsShellVertexHandle p[]);

	template <const int N>
	YSRESULT CutByPolygon(YsShellExtEdit &shl,const YsArray <YsVec3,N> &p);
	template <const int N>
	YSRESULT CutByPolygon(YsShellExtEdit &shl,const YsArray <YsShellVertexHandle,N> &p);
};

template <const int N>
YSRESULT YsShellExtEdit_CutByPlane::CutByPolygon(YsShellExtEdit &shl,const YsArray <YsVec3,N> &p)
{
	return CutByPolygon(shl,(int)p.GetN(),p);
}

template <const int N>
YSRESULT YsShellExtEdit_CutByPlane::CutByPolygon(YsShellExtEdit &shl,const YsArray <YsShellVertexHandle,N> &p)
{
	return CutByPolygon(shl,p.GetN(),p);
}


/* } */
#endif

